#include "Analyze.h"

//ANALYZOR
Analyzor::Analyzor(char * path,Intelligent **mycomp){
	online = myarray = onename = 0;
	endline = 0;

	testfile.open(path);

	if (!testfile){
		string pass = "File not found : ";
		pass += path;
		throw file(pass);
	}

	try{
		checker();
	}catch(...){
		testfile.close();
		throw;
	}

	testfile.close();//reuse of file needed

	try{
		infile.open(path);

		infile.get(nextline);  
		length = 256;
		onename = new char[2];

		if (onename == 0)
			throw outmem("Out of memory");
		
		strcpy(onename,"@");

		makecomponents();
		*mycomp = new Intelligent(tempimp,tempIQ,tempprimitives,tempinum,tempoutnum,tempmykind);

		if (*mycomp == 0)
			throw outmem("Out of memory");

		(*mycomp)->wireblank(wt.size());
	}catch(...){
		infile.close();

		if (onename != 0)
			delete []onename;

		onename = 0;

		if (myarray != 0)
			delete []myarray;

		onename = 0;

		throw;
	}
}

//~ANALYZOR
Analyzor::~Analyzor(){
	infile.close();

	if (onename != 0)
		delete []onename;

	if (myarray != 0)
		delete []myarray;
}

//CHECKER
void Analyzor::checker(){
	char mychar = '0',before = '0',before2 = '0';//object's field for determining EOF(nextline)
	char tempol[256];
	
	while(! testfile.eof()){
		if (!((mychar >= 'a' && mychar <= 'z') || (mychar >= 'A' && mychar <= 'Z') || (mychar >= '0' && mychar <= '9') || (mychar == 47/* / */) || (mychar == ',') || (mychar == '(') || (mychar == ')') || (mychar == ';') || (mychar == ':') || (mychar == '=') || (mychar == '&') || (mychar == 9/*tab*/) || (mychar == 32 /*space*/) || (mychar == 10 /*eoln*/) || (mychar == -1 /*eof*/))){
			string pass = "Unallowed character found : ";
			pass += mychar;
			throw syntax(pass);
		}else{
			if (mychar == 47){
				if(before == 47)
					testfile.getline(tempol,255);
				before = 47;
			}
			
			if (mychar == ','){
				if(before2 == ','){
					string pass = "Two , are nearby";
					throw syntax(pass);
				}

				before2 = ',';
			}

			if (mychar == 10 && before2 == ','){
				string pass = ", apears in first";
				throw syntax(pass);
			}

			if (mychar != ',')
				before2 = '0';
		}

		testfile.get(mychar);//objects field(Fmyfile)
	}
}

//RETURN_LINE
void Analyzor::return_line(){
	char mychar = nextline;//object's field for determining EOF(nextline)
	char temparray[256];
	int count;
	
	for(count = 0;(count < length - 2) && (mychar != 10/*return*/) && (!infile.eof());count++){
		temparray[count] = tolower(mychar);
		infile.get(mychar);//objects field(Fmyfile)
	}
	
	if (count <= length - 1)//length is object's field
		temparray[count] = '\0';//my array is object's field

	if (count >= length - 2){//line lenght is bigger than our predect
		string pass = "Length of line is bigger than 255";
		throw syntax(pass);
	}
	
	if (infile.eof())
		nextline = -1;
	else{
		infile.get(nextline);

		while((nextline == 10 || nextline == 9 || nextline == 32) && !infile.eof())
			infile.get(nextline);

		if(infile.eof())
			nextline = -1;
	}

	if(myarray != 0)
		delete[] myarray;

	myarray = new char [strlen(temparray) + 1];

	if (myarray == 0)
		throw outmem("Out of memory");

	strcpy(myarray,temparray);
	online = myarray;//pointer to somewhere in line is setted
	endline = 0;
}

//TOKENER
void Analyzor::tokener(){
	int namecounter = 0;
	char tempname[20];
	endline = 0;
	
	if (onename != 0)
		delete []onename;

	onename = new char[2];

	if (onename == 0)
		throw outmem("Out of memory");

	strcpy(onename,"@");

	//online is pointer in some place in the line and a field
	while ((*online == 9) || (*online == 32))
		online++;

	if (*online != 0){
		if (!((*online >= 'a' && *online <= 'z') || (*online >= '0' && *online <= '9'))){
			tempname[namecounter++] = *online;
			online++;
		}

		else{
			while ((namecounter < 20) && ((*online >= 'a' && *online <= 'z') || (*online >= '0' && *online <= '9'))){
				tempname[namecounter++] = *online;//onename is a field
				online++;
			}
			if(namecounter >= 20){
				string pass = "Name length must be maximum 20";
				throw syntax(pass);
			}
		}
	}
	else{
		if(nextline != -1)
			return_line();
		else
			nextline = '#';

		endline = 1;
		strcpy(tempname,"@");
	}

	tempname[namecounter] = 0;

	if (onename != 0)
		delete []onename;

	onename = new char [strlen(tempname) + 1];

	if (onename == 0)
		throw outmem("Out of memory");

	strcpy(onename,tempname);
}

//CHAR2STRING
string Analyzor::char2string(const char * orig){
	string result;

	for(;*orig != 0;orig++)
		result += *orig;

	return result;
}

//HARRY_INPUT
void Analyzor::harry_input(){
	tokener();
	int count = 0;

	while(endline != 1){
		if((onename[0] >= 'a' && onename[0] <= 'z') || (onename[0] >= '0' && onename[0] <= '9'))
			it.push_back(char2string(onename));
		else if(onename[0] != ','){
			string pass = "Unallowed character in argument list";
			throw syntax(pass);
		}else if(it.size() == 0){
			string pass = "Input with no parameters";
			throw syntax(pass);		
		}else
			count++;

		tokener();
	}

	tempinum = it.size();
}

//HARRY_OUTPUT
void Analyzor::harry_output(){
	tokener();
	int count = 0;

	while(endline != 1){
		if((onename[0] >= 'a' && onename[0] <= 'z') || (onename[0] >= '0' && onename[0] <= '9'))
			ot.push_back(char2string(onename));
		else if(onename[0] != ','){
			string pass = "Unallowed character in argument list";
			throw syntax(pass);
		}else if(ot.size() == 0){
			string pass = "Output with no parameters";
			throw syntax(pass);		
		}else
			count++;

		tokener();
	}

	tempoutnum = ot.size();
}

//HARRY_WIRE
void Analyzor::harry_wire(){
	tokener();

	while(endline != 1){
		if((onename[0] >= 'a' && onename[0] <= 'z') || (onename[0] >= '0' && onename[0] <= '9'))
			wt.push_back(char2string(onename));
		else if(onename[0] != ','){
			string pass = "Unallowed character in argument list";
			throw syntax(pass);
		}else if(wt.size() == 0){
			string pass = "Wire with no parameters";
			throw syntax(pass);		
		}

		tokener();
	}
}

//FINDPLACE
void Analyzor::findplace(char &family,char &place){
	family = 'i';
	int count;

	for (count = 0;count < it.size();count++){
		if(it[count] == char2string(onename)){
			place = count;
			return;
		}
	}

	family = 'o';

	for (count = 0;count < ot.size();count++){
		if(ot[count] == char2string(onename)){
			place = count;
			return;
		}
	}

	family = 'w';

	for (count = 0;count < wt.size();count++){
		if(wt[count] == char2string(onename)){
			place = count;
			return;
		}
	}

	string pass = "Unknoen identifier : ";
	pass += onename;
	throw argument(pass);
}

//ARGER
void Analyzor::arger(int outer){
	int count = 0;
	char kind,number;
	tokener();

	if ((onename[0] >= 'a' && onename[0] <= 'z') || (onename[0] >= '0' && onename[0] <= '9'))//its name
		tokener();

	if(onename[0] != '('){
		string pass = "Ambigus (";
		throw syntax(pass);
	}

	tokener();
	while(onename[0] != ')' && nextline != '#'){
		if ((onename[0] >= 'a' && onename[0] <= 'z') || (onename[0] >= '0' && onename[0] <= '9')){
			findplace(kind,number);
			tempimp += kind;
			tempimp += number;
			tempimp += ' ';
			count++;

			if(count == outer)
				tempimp += "# ";
		}else if (onename[0] != ','){
				string pass = "Unallowed character in argument list : ";
				pass += onename[0];
				throw syntax(pass);
		}

		tokener();
	}

	tempimp += '!';

	while (nextline != '#' && !((onename[0] >= 'a' && onename[0] <= 'z') || (onename[0] >= '0' && onename[0] <= '9')))
		tokener();

	if (nextline == '#' || count <= outer)
		throw(3);//end or another gates must exist
}

//PROBER
void Analyzor::prober(){
	char kind,number;
	tokener();

	if(!((onename[0] >= 'a' && onename[0] <= 'z') || (onename[0] >= '0' && onename[0] <= '9'))){
		string pass = "After prob name expected";
		throw syntax(pass);
	}

	findplace(kind,number);
	tempimp += kind;
	tempimp += number;
	tempimp += " # ";

	tokener();
		
	if(onename[0] != ','){
		string pass = "Where is , in prob's argument list";
		throw syntax(pass);
	}

	tokener();

	if(!((onename[0] >= 'a' && onename[0] <= 'z') || (onename[0] >= '0' && onename[0] <= '9'))){
		string pass = "Where is second name in prob's argument list";
		throw syntax(pass);
	}

	findplace(kind,number);
	tempimp += kind;
	tempimp += number;
	tempimp += " !";

	while(endline != 1)
		tokener();

	while (nextline != '#' && !((onename[0] >= 'a' && onename[0] <= 'z') || (onename[0] >= '0' && onename[0] <= '9')))
		tokener();

	if (nextline == '#'){
		string pass = "Unexpected end of file";
		throw syntax(pass);
	}
}

//LINEPROCESSOR
void Analyzor::lineprocessor(){
	vector<bool> my01s;
	int index,outdex,loop,count = 0;

	while(endline == 0){
		if(onename[0] == '0'){
			my01s.push_back(0);
			count++;
		}

		if(onename[0] == '1'){
			my01s.push_back(1);
			count++;
		}

		tokener();
	}

	if (count != tempinum + tempoutnum){
		string pass = "In truth table number of 01s nut matched to number of inputs + outputs";
		throw syntax(pass);
	}

	index = 0;

	for(loop = 0;loop < tempinum;loop++)
		index = my01s[loop] + index * 2;

	outdex = 0;

	for(loop = tempinum;loop < tempinum + tempoutnum;loop++)
		outdex = my01s[loop] + outdex * 2;

	tempimp[index] = (char)outdex;

	while (nextline != '#' && !((onename[0] >= 'a' && onename[0] <= 'z') || (onename[0] >= '0' && onename[0] <= '9')))
		tokener();

	if (nextline == '#'){
		string pass = "Unexpected end of file";
		throw syntax(pass);
	}
}

//HARRY_TRUTH
void Analyzor::harry_truth(){
	tempmykind = 0;
	int mysize = pow(2,tempinum);

	for(int mycounter = 0;mycounter < mysize;mycounter++)
		tempimp += (char)0;

	tokener();

	while(strcmp(onename,"end") != 0 && (nextline != '#')){
		while((nextline != '#') && !((onename[0] >= 'a' && onename[0] <= 'z') || (onename[0] >= '0' && onename[0] <= '9')))
			tokener();

		if(nextline == '#'){
			string pass = "Unexpected end of file";
			throw syntax(pass);
		}

		if(onename[0] == '0' || onename[0] == '1')
			lineprocessor();
		else if (strcmp(onename,"end") != 0)
			throw(3);
	}

	if (nextline == '#'){
		string pass = "Unexpected end of file";
		throw syntax(pass);
	}

	tokener();
	
	if (strcmp(onename,"truthtable") != 0){
		string pass = "Where is end truthtable";
		throw syntax(pass);
	}
}

//HARRY_DESCRIP
void Analyzor::harry_descrip(){
	tempmykind = 1;
	tokener();

	while((nextline != '#') && !((onename[0] >= 'a' && onename[0] <= 'z') || (onename[0] >= '0' && onename[0] <= '9')))
		tokener();

	if(nextline == '#'){
		string pass = "Unexpected end of file";
		throw syntax(pass);
	}

	while((nextline != '#') && strcmp(onename,"end") != 0)
		determiner();

	if(nextline == '#'){
		string pass = "Unexpected end of file";
		throw syntax(pass);
	}

	tokener();

	if(strcmp(onename,"description") != 0){
		string pass = "Where is end description";
		throw syntax(pass);
	}
}

//DETERMINER
void Analyzor::determiner(){
	if ((strcmp(onename,"not") == 0) ||	(strcmp(onename,"and") == 0) ||	(strcmp(onename,"nand") == 0) || (strcmp(onename,"or") == 0) ||	(strcmp(onename,"nor") == 0) || (strcmp(onename,"xor") == 0) ||	(strcmp(onename,"xnor") == 0) || (strcmp(onename,"multiplexer") == 0) || (strcmp(onename,"dff") == 0)){
		tempimp += 'p';
		primer();
	}else if(strcmp(onename,"prob") == 0){
		tempimp += 'n';
		tempimp += ' ';
		prober();
	}else{
		tempimp += "v";
		intelligenter();
	}
}

//PRIMER
void Analyzor::primer(){
	Component *mustinsert = 0;
	int argerpass = 1;//every except DFF

	if(strcmp(onename,"not") == 0)
		mustinsert = new NOT();
	else if(strcmp(onename,"and") == 0)
		mustinsert = new AND();
	else if(strcmp(onename,"nand") == 0)
		mustinsert = new NAND();
	else if(strcmp(onename,"or") == 0)
		mustinsert = new OR();
	else if(strcmp(onename,"nor") == 0)
		mustinsert = new NOR();
	else if(strcmp(onename,"xor") == 0)
		mustinsert = new XOR();
	else if(strcmp(onename,"xnor") == 0)
		mustinsert = new XNOR();
	else if(strcmp(onename,"multiplexer") == 0)
		mustinsert = new MULT();
	else if(strcmp(onename,"dff") == 0){
		mustinsert = new DFF();
		argerpass = 2;
	}else
		cout << "NEVER!!!!!!!" << endl;

	if (mustinsert == 0)
		throw outmem("Out of memory");

	tempprimitives.push_back(mustinsert);
	int place = tempprimitives.size() - 1;
	tempimp += (char)place;
	tempimp += ' ';

	try{
		arger(argerpass);
	}catch(...){
		if (mustinsert != 0)
			delete mustinsert;

		throw;
	}
}

//MAKECOMPONENTS
void Analyzor::makecomponents(){
	return_line();

	while(strcmp(onename,"input") != 0 && nextline != '#')
		tokener();

	if(nextline == '#'){
		string pass = "Unexpected end of file";
		throw syntax(pass);
	}

	harry_input();

	while(strcmp(onename,"output") != 0 && nextline != '#')
		tokener();

	if(nextline == '#'){
		string pass = "Unexpected end of file";
		throw syntax(pass);
	}

	harry_output();

	while(strcmp(onename,"wire") != 0 && strcmp(onename,"description") != 0 && strcmp(onename,"truthtable") != 0 && nextline != '#')
		tokener();

	if(nextline == '#'){
		string pass = "Unexpected end of file";
		throw syntax(pass);
	}

	if(strcmp(onename,"wire") == 0)
		harry_wire();

	while(strcmp(onename,"description") != 0 && strcmp(onename,"truthtable") != 0 && nextline != '#')
		tokener();

	if(nextline == '#'){
		string pass = "Unexpected end of file";
		throw syntax(pass);
	}
	
	if(strcmp(onename,"description") == 0)
		harry_descrip();
	else if(strcmp(onename,"truthtable") == 0)
		harry_truth();
}


//INTELLIGENTER
void Analyzor::intelligenter(){
	char *myaddress = 0;
	Intelligent *mustinsert = 0;

	myaddress = new char [strlen(onename) + 5];

	if (myaddress == 0)
		throw outmem("Out of memory");

	strcpy(myaddress,onename);
	strcat(myaddress,".crt");

	try{
		Analyzor(myaddress,&mustinsert);
		tempIQ.push_back(mustinsert);

		int place = tempIQ.size() - 1;
		tempimp += (char)place;

		arger(tempIQ[place]->getout());
	}catch(...){
		if(myaddress == 0)
			delete myaddress;

		if(mustinsert == 0)
			delete mustinsert;
	}
}

