#include <afxwin.h>
#include <stdlib.h>
#include "CWave.h"
#include "App_ids.h"
#include "Circuit.h"
#include "resource.h"

CWave :: CWave( int Time,Circuit * joojoo)
{
	Create(NULL,"WaveForm",~WS_THICKFRAME &		
        ~WS_MAXIMIZEBOX &		
        WS_OVERLAPPEDWINDOW, 
		CRect( 115, 45, 685, 555) );
	HICON hicon=AfxGetApp()->LoadIcon(IDR_ICON2);
    SetIcon(hicon,FALSE);
	SetIcon(hicon,TRUE);
	CButton* myButton1 = new CButton;
	myButton1->Create(_T("Ok"), WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON, 
    CRect(205,435,350,455), this , 1);
	myButton1->SetDlgCtrlID(IDC_MYBUTTON);
	time = Time;
	if ( time <= 50 ) mode = 0;
	else if ( time <= 100) mode = 1;
	else if ( time <= 500) mode = 2;
	
	switch (mode)
	{
	case(0):
		unitx = 10;
		break;
	case(1):
		unitx = 5;
		break;
	case(2):
		unitx = 1;
		break;
	}
	switch( mode )
	{
	case 0:
		unitx = 10;
		break;
	case 1:
		unitx = 5;
		break;
	case 2:
		unitx = 1;
		break;
	}

	ramtin = joojoo;
}

void afx_msg CWave::OnMyButton( ) 
{
	SendMessage(WM_CLOSE);
}

void CWave::Joiner( bool past, bool now, POINT po, CPaintDC* dc)
{
	dc->MoveTo( po.x, po.y);
	if ( ( past==0 ) && ( now==0) ) 
	{
		dc->LineTo(po.x+unitx,po.y);
	}
	if ( ( past == 1) && ( now == 1 ) )
	{
		dc->MoveTo(po.x,po.y-unity/2);
		dc->LineTo(po.x+unitx,po.y-unity/2);
	}

	if ( (past==0) && (now==1) )
	{
		dc->LineTo(po.x,po.y-unity/2);
		dc->LineTo(po.x+unitx,po.y-unity/2);
	}
	if ( (past==1) && (now==0) )
	{
		dc->LineTo(po.x,po.y-unity/2);
		dc->MoveTo(po.x,po.y);
		dc->LineTo(po.x+unitx,po.y);
	}
}

void afx_msg CWave::OnPaint()
{
	CPaintDC dc ( this );
	CBrush brush;
	brush.CreateSolidBrush( RGB( 242,255,244) );
	CBrush * pOld = dc.SelectObject( &brush );
	dc.Rectangle( 30, 10, 530, 410);
	dc.SelectObject( pOld );
	
	CPen pen;
	pen.CreatePen( PS_SOLID, 1 , RGB( 196, 196, 196) );
	CPen* oldpen = dc.SelectObject( &pen );
	for ( int i = 1; i < 100 ; i++)
	{
		dc.MoveTo( 30+5*i,11);
		dc.LineTo( 30+5*i,409);
	}

	for( i=1 ; i < 80 ; i++)
	{
		dc.MoveTo( 31,10+5*i);
		dc.LineTo( 529,10+5*i);
	}
	dc.SelectObject( oldpen);
	for ( i = 0 ; i < 5 ; i++)
	{
		dc.MoveTo( 30+100*i,11);
		dc.LineTo( 30+100*i,409);
	}
	for ( i = 0 ; i < 4 ; i++)
	{
		dc.MoveTo( 31,10+100*i);
		dc.LineTo( 529,10+100*i);
	}

	char* buffer ;
	buffer = new char[100];
	for ( i=0;i<4;i++)
		buffer[i]='\0';
	int unt;
	switch( mode )
	{
	case 0:
		unt = 10;
		break;
	case 1:
		unt = 20;
		break;
	case 2:
		unt = 100;
		break;
	}
	dc.TextOut(25,415,"0",1);
	for ( i=1 ; i <= 5 ; i++)
		dc.TextOut(25 + 100*i ,415,itoa (i*unt,buffer,10),
		(i*unt<100)?2:3);
	delete[] buffer;
	CPen red;
	red.CreatePen( PS_SOLID , 3 , RGB(255,0,0) );
	CPen* old = dc .SelectObject( &red);

	ramtin->get(d_in,d_out);

	last_in.clear();
	last_out.clear();
	for( int k = 0; k < d_in.size();k++)
		last_in.push_back(0);
	for( k = 0; k < d_out.size();k++)
		last_out.push_back(0);
	
	unity = 400 / ( d_in.size() + d_out.size() +1  );
	POINT cur;
	for( int sec = 0; sec< time ; sec++)
	{
		for ( int i = 0;i<d_in.size();i++)
		{
			cur.x = sec * unitx + 30;
			cur.y = ( i + 1 ) * unity + 10;
			Joiner(last_in[i],d_in[i],cur,&dc);
		}
		for ( int j = 0;j<d_out.size();j++)	
		{
			cur.x = sec * unitx + 30;
			cur.y = ( j + 1 + d_in.size() ) *unity + 10;
			Joiner(last_out[j],d_out[j],cur,&dc);
		}
		last_in = d_in;
		last_out = d_out;
		
		ramtin->get(d_in,d_out);
	}
	dc.SelectObject( old );
}
/*
vector<bool> CWave::get_in()
{
	vector<bool> temp;
	for( int index=0;index<2;index++)
		temp.push_back( rand() % 2);
	int kashk = temp[1];
	return temp;

}
		
vector<bool> CWave::get_out()
{
	vector<bool> temp;
	for( int index=0;index<2;index++)
		temp.push_back( rand() % 2);
	return temp;
}
*/
void CWave::draw()
{
	
}

BEGIN_MESSAGE_MAP( CWave, CFrameWnd)
	ON_WM_PAINT()
//	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED( IDC_MYBUTTON, OnMyButton )
END_MESSAGE_MAP()

/*class CWaveApp : public CWinApp
{
public:
	BOOL InitInstance()
	{
		m_pMainWnd = new CWave(5);
		m_pMainWnd -> ShowWindow( m_nCmdShow );
		m_pMainWnd -> UpdateWindow();
		
		vector<bool> yahoo;
		yahoo.push_back(0);
		yahoo.push_back(1);
		yahoo.push_back(1);

		vector<bool> yohoo;
		yohoo.push_back(1);
		yohoo.push_back(1);
		yohoo.push_back(0);
		
		CWave * my =(CWave *)m_pMainWnd;
		//my->set(yahoo,yohoo);
		
		return TRUE;
	}
} ob ;*/