#include "HN.h"
#include "Exeption.h"

//NOT***********************************************************
void NOT::evaluate()
{
	o.resize(0);
	o.push_back(not( i ));
	used = 1;
}
void NOT::set(vector<bool> inputed)
{
	if (inputed.size() != 1){
		string pass = "There is an error in number of not's inputs";
		throw size(pass);
	}else  
		i = inputed;
}

bool NOT::not(vector<bool> lnot){
	return !lnot[0];
}


//AND NAND***********************************************************
void AND::evaluate()
{
	o.resize(0);
	o.push_back(and( i ));
	used = 1;
}
void AND::set(vector<bool> inputed)
{
	if ( inputed.size() < 2 || inputed.size() > 8 ){
		string pass = "There is an error in number of and's inputs";
		throw size(pass);
	}else 
		i = inputed;
}

bool AND::and(vector<bool> land){
	int size = land.size();
	bool out = 1;
	for (int count = 0;(count < size) && out;count++)
		out = out && land[count];
	return out;
}

void NAND::evaluate()
{
	o.resize(0);
	o.push_back(nand( i ));
	used = 1;
}

void NAND::set(vector<bool> inputed )
{
	if ( inputed.size() < 2 || inputed.size() > 8 ) {
		string pass = "There is an error in number of nand's inputs";
		throw size(pass);
	}else
		i = inputed;
}

bool NAND::nand(vector<bool> lnand){
	return !and(lnand);
}

bool NAND::and(vector<bool> land){
	int size = land.size();
	bool out = 1;
	for (int count = 0;(count < size) && out;count++)
		out = out && land[count];
	return out;
}


//OR NOR***********************************************************
void OR::evaluate()
{
	o.resize(0);
	o.push_back(or( i ));
	used = 1;
}

void OR::set(vector<bool> inputed)
{
	if ( inputed.size() < 2 || inputed.size() > 8 ){
		string pass = "There is an error in number of or's inputs";
		throw size(pass);
	}else 
		i = inputed;
}

bool OR::or(vector<bool> lor){
	int size = lor.size();
	bool out = 0;
	for (int count = 0;(count < size) && !out;count++)
		out = out || lor[count];
	return out;
}

void NOR::evaluate()
{
	o.resize(0);
	o.push_back(nor( i ));
	used = 1;
}

void NOR::set(vector<bool> inputed)
{
	if ( inputed.size() < 2 || inputed.size() > 8 ){
		string pass = "There is an error in number of nor's inputs";
		throw size(pass);
	}else
		i = inputed;
}

bool NOR::or(vector<bool> lor){
	int size = lor.size();
	bool out = 0;
	for (int count = 0;(count < size) && !out;count++)
		out = out || lor[count];
	return out;
}

bool NOR::nor(vector<bool> lnor){
	return !or(lnor);
}

//XOR XNOR***********************************************************
void XOR::evaluate()
{
	o.resize(0);
	o.push_back(xor( i ));
	used = 1;
}

void XOR::set(vector<bool> inputed)
{
	if (inputed.size()!=2){
		string pass = "There is an error in number of xor's inputs";
		throw size(pass);
	}else
		i = inputed;
}

bool XOR::xor(vector<bool> lxor){
	return (lxor[0] != lxor[1]);
}

void XNOR::evaluate()
{
	o.resize(0);
	o.push_back(xnor( i ));
	used = 1;
}

void XNOR::set( vector<bool> inputed)
{
	if (inputed.size()!=2){
		string pass = "There is an error in number of xnor's inputs";
		throw size(pass);
	}else
		i = inputed;
}

bool XNOR::xor(vector<bool> lxor){
	return (lxor[0] != lxor[1]);
}

bool XNOR::xnor(vector<bool> lxnor){
	return !xor(lxnor);
}

//MULT***********************************************************
void MULT::evaluate()
{
	o.resize(0);
	o.push_back(mult( i ));
	used = 1;
}

void MULT::set(vector<bool> inputed)
{
	if (inputed.size() != 3 && inputed.size() != 6){
		string pass = "There is an error in number of multiplexer's inputs";
		throw size(pass);
	}else
		i = inputed;
}

bool MULT::mult(vector<bool> lmult){
	if (lmult.size() == 3){
		if(lmult[2])
			return lmult[1];
		else
			return lmult[0];
	}else if (lmult.size() == 6){
		int select = lmult[5] + lmult[4] * 2;
		
		switch (select){
		case 0:
			return lmult[0];
			break;
		case 1:
			return lmult[1];
			break;
		case 2:
			return lmult[2];
			break;
		case 3:
			return lmult[3];
			break;
		}
	}else
		throw(1);

}

//DFF***********************************************************
DFF::DFF(){
	detect = 9;
	store = pclock = change = 0;
}

void DFF::set(vector<bool> inputed){
	if (inputed.size() != 2){
		string pass = "There is an error in number of delayed-fleep-flop's inputs";
		throw size(pass);
	}else
		i = inputed;
}

void DFF::evaluate(){
	if(pclock == 0 && i[1] == 1){
		if (store != i[0]){
			store = i[0];
			change = 1;

			vector<bool> mustequal;
			mustequal.push_back(store);
			mustequal.push_back(!store);
			o = mustequal;
		}else{
			vector<bool> mustequal;
			mustequal.push_back(store);
			mustequal.push_back(!store);
			o = mustequal;
		}
	}else{
		vector<bool> mustequal;
		mustequal.push_back(store);
		mustequal.push_back(!store);
		o = mustequal;
	}
	pclock = i[1];

	if (used == 0){
		change = 1;
		used = 1;
	}
}

//TNTELLIGENT***********************************************************
Intelligent::Intelligent(string implement,vector<Intelligent *> IQer,vector<Component *> primitiveser,int inumer,int outnumer,bool mykinder){
	detect = 0;
	imp = implement;
	IQ = IQer;
	primitives = primitiveser;
	inum = inumer;
	outnum = outnumer;
	mykind = mykinder;
	o.resize(outnum);
}

Intelligent::~Intelligent(){
	for (int i = 0; i < IQ.size();i++)
		if(IQ[i] != 0)
			delete IQ[i];

	for (i = 0; i < primitives.size();i++)
		if(primitives[i] != 0)
			delete primitives[i];
}

void Intelligent::set(vector<bool> inputed){
	if (inputed.size() != inum){
		string pass = "There is an error in number of one of user sefined's inputs";
		throw size(pass);
	}else
		i = inputed;
}


void Intelligent::wireblank(int mysize){
	iw.resize(mysize);
}

//RESET
void Intelligent::reset(){
	int counter;

	for(counter = 0;counter < iw.size();counter++)
		iw[counter].state = 'u';

	for(counter = 0;counter < IQ.size();counter++)
		IQ[counter]->setuse(0);

	for(counter = 0;counter < primitives.size();counter++){
		primitives[counter]->setuse(0);

		if(primitives[counter]->getdet() == 9){
			DFF *point = (DFF*)primitives[counter];
			point->resetchange();
		}
	}
}

//VALIDITY
bool Intelligent::validity(int position){
	vector<int> trust;

	for(int count = position;imp[count] != '#';count++);

	for(;imp[count] != '!';count++)
		if(imp[count] == 'w')
			trust.push_back((int)imp[count + 1]);

	for(count = 0;count < trust.size();count++)
		if(iw[trust[count]].state != 'v' && iw[trust[count]].state != 'h')
			return 0;

	return 1;
}

//ENDPRIM
bool Intelligent::endprim(int position){
	vector<int> trust;

	if(!(primitives[(int)imp[position + 1]]->getuse()))
		return 0;

	for(int count = position;imp[count] != '#';count++);

	for(;imp[count] != '!';count++)
		if(imp[count] == 'w')
			trust.push_back((int)imp[count + 1]);

	for(count = 0;count < trust.size();count++)
		if(!(iw[trust[count]].state == 'v' && primitives[(int)imp[position + 1]]->getuse()))
			return 0;

	return 1;
}

//ENDINTE
bool Intelligent::endinte(int position){
	vector<int> trust;

	if(!(IQ[(int)imp[position + 1]]->getuse()))
		return 0;

	for(int count = position;imp[count] != '#';count++);

	for(;imp[count] != '!';count++)
		if(imp[count] == 'w')
			trust.push_back((int)imp[count + 1]);

	for(count = 0;count < trust.size();count++)
		if(!(iw[trust[count]].state == 'v' && IQ[(int)imp[position + 1]]->getuse()))
			return 0;

	return 1;
}

//TRANSTRUTH
void Intelligent::transtruth(int position){
	vector<bool> mustset;
	int outcounter = 0;
	int count = position;
	bool hot = 0;

	for(;imp[count] != '#';count++);

	while(imp[count] != '!'){
		if(imp[count] == 'i')
			mustset.push_back(i[(int)imp[count + 1]]);
		else if(imp[count] == 'w'){
			mustset.push_back(iw[(int)imp[count + 1]].value);
	
			if(iw[(int)imp[count + 1]].state == 'h'){
				hot = 1;
				iw[(int)imp[count + 1]].state = 'v';
			}
		}
		else if(imp[count] == 'o'){
			string pass = "Input of one gate cannot be output of component";
			throw syntax(pass);
		}
		count++;
	}

	int region = imp[position + 1];
	int index = 0;

	for(int loop = 0;loop < mustset.size();loop++)
		index = mustset[loop] + index * 2;

	int outdex = (int)IQ[region]->imp[index];

	for(loop = outnum - 1;loop >= 0;loop --)
		mustset[loop] = outdex - (outdex % 2) * 2;

	count = position;
	while(imp[count] != '#'){
		if(imp[count] == 'o')
			o[(int)imp[count + 1]] = mustset[outcounter++];
		else if(imp[count] == 'w'){
			iw[(int)imp[count + 1]].value = mustset[outcounter++];

			if (hot == 0)
				iw[(int)imp[count + 1]].state = 'v';
			else
				iw[(int)imp[count + 1]].state = 'h';
		}
		else if(imp[count] == 'i'){
			string pass = "Output of one gate cannot be input of component";
			throw syntax(pass);
		}

		count++;
	}
}

//TRANSLATE
void Intelligent::translate(int position){
	vector<bool> mustset;
	int count = position;
	bool hot = 0;

	for(;imp[count] != '#';count++);

	while(imp[count] != '!'){
		if(imp[count] == 'i')
			mustset.push_back(i[(int)imp[count + 1]]);
		else if(imp[count] == 'w'){
			mustset.push_back(iw[(int)imp[count + 1]].value);
	
			if(iw[(int)imp[count + 1]].state == 'h'){
				hot = 1;
				iw[(int)imp[count + 1]].state = 'v';
			}
		}
		else if(imp[count] == 'o'){
			string pass = "Input of one gate cannot be output of component";
			throw syntax(pass);
		}

		count++;
	}

	int region = imp[position + 1];

	if(imp[position] == 'p'){
		primitives[region]->set(mustset);
		primitives[region]->evaluate();
		mustset = primitives[region]->get();
	}else if(imp[position] == 'v'){
		IQ[region]->set(mustset);
		IQ[region]->evaluate();
		mustset = IQ[region]->get();
	}else 
		throw(5);

	int outcounter = 0;
	count = position;

	if(imp[position] == 'p'){
		if(!detectdff(position)){
			while(imp[count] != '#'){
				if(imp[count] == 'o')
					o[(int)imp[count + 1]] = mustset[outcounter++];
				else if(imp[count] == 'w'){
					iw[(int)imp[count + 1]].value = mustset[outcounter++];

					if (hot == 0)
						iw[(int)imp[count + 1]].state = 'v';
					else
						iw[(int)imp[count + 1]].state = 'h';
				}
				else if(imp[count] == 'i'){
					string pass = "Output of one gate cannot be input of component";
					throw syntax(pass);
				}

				count++;
			}
		}else{
			DFF *point = (DFF*)primitives[(int)imp[position + 1]];
			count = position;

			if(point->getchange() == 1){
				point->resetchange();
	
				while(imp[count] != '#'){
					if(imp[count] == 'o')
						o[(int)imp[count + 1]] = mustset[outcounter++];
					else if(imp[count] == 'w'){
						iw[(int)imp[count + 1]].value = mustset[outcounter++];
						iw[(int)imp[count + 1]].state = 'h';
					}
					else if(imp[count] == 'i'){
						string pass = "Output of one gate cannot be input of component";
						throw syntax(pass);
					}

					count++;
				}
			}
		}
	}else if(imp[position] == 'v'){
		while(imp[count] != '#'){
			if(imp[count] == 'o')
				o[(int)imp[count + 1]] = mustset[outcounter++];
			else if(imp[count] == 'w'){
				iw[(int)imp[count + 1]].value = mustset[outcounter++];

				if (hot == 0)
					iw[(int)imp[count + 1]].state = 'v';
				else
					iw[(int)imp[count + 1]].state = 'h';
			}
			else if(imp[count] == 'i'){
				string pass = "Output of one gate cannot be input of component";
				throw syntax(pass);
			}

			count++;
		}
	}

}

//DETECTDFF
bool Intelligent::detectdff(int position){
	if(primitives[(int)imp[position + 1]]->getdet() == 9)
		return 1;
	else
		return 0;
}

//CHECKPROB
void Intelligent::checkprob(int position){
	int count = position;


	while(imp[count] != '#'){
		if(imp[count] == 'i'){
			string pass = "Prob's first argument must be an output";
			throw syntax(pass);
		}else if(imp[count] == 'w'){
			string pass = "Prob's first argument must be an output";
			throw syntax(pass);
		}

		count++;
	}
			
	while(imp[count] != '!'){
		if(imp[count] == 'i'){
			string pass = "Prob's second argument must be a wire";
			throw syntax(pass);
		}else if(imp[count] == 'o'){
			string pass = "Prob's second argument must be a wire";
			throw syntax(pass);
		}

		count++;
	}
}

//SETPROB
void Intelligent::setprob(int position){
	int count = position;
	int outindex = -1;

	while(imp[count] != '#'){
		if(imp[count] == 'o')
			outindex = imp[count + 1];

		count++;
	}

	if (outindex == -1){
		string pass = "Prob's first argument must be an output";
		throw syntax(pass);
	}
			
	while(imp[count] != '!'){
		if(imp[count] == 'w'){
			o[outindex] = iw[(int)imp[count + 1]].value;
		}
		count++;
	}
}	

//PREDFF
void Intelligent::predff(){
	for(int count = 0;count < imp.size();count++){
		if(imp[count] == 'p' && detectdff(count)){
			DFF *point = (DFF*)primitives[(int)imp[count + 1]];

			while(imp[count] != 'o' && imp[count] != 'w' && imp[count] != '#')
				count++;

			if(imp[count] == '#'){
				string pass = "Unexpected end of file";
				throw syntax(pass);
			}

			if(imp[count] == 'w'){
				iw[(int)imp[count + 1]].value = point->getstore();
				iw[(int)imp[count + 1]].state = 'v';
			}

			count++;

			while(imp[count] != 'o' && imp[count] != 'w' && imp[count] != '#')
				count++;
				
			if(imp[count] == '#'){
				string pass = "Unexpected end of file";
				throw syntax(pass);
			}

			if(imp[count] == 'w'){
				iw[(int)imp[count + 1]].value = !point->getstore();
				iw[(int)imp[count + 1]].state = 'v';
			}
		}
	}
}

//INTELDETERMINE
void Intelligent::inteldetermine(int position){
	if(IQ[(int)imp[position + 1]]->mykind == 0)
		transtruth(position);
	else if(IQ[(int)imp[position + 1]]->mykind == 1)
		translate(position);
}

//EVALUATE
void Intelligent::evaluate(){
	bool flag = 0;
	int indicate;
	reset();
	predff();

	while(flag == 0){
		flag = 1;

		for(indicate = 0;indicate < imp.size();indicate++){
			if(imp[indicate] == 'p' && !endprim(indicate)){
				if(validity(indicate))
					translate(indicate);
				else
					flag = 0;
			}else if(imp[indicate] == 'v' && !endinte(indicate)){
				if(validity(indicate))
					inteldetermine(indicate);
				else
					flag = 0;
			}
		}
	}

	for(indicate = 0;indicate < imp.size();indicate++){
		if(imp[indicate] == 'n'){
			checkprob(indicate);
			setprob(indicate);
		}
	}
}

