#ifndef __HN_H_
#define __HN_H_

#include <string>
#include <vector>
#include <fstream>
#include <iostream>

using namespace std;

class Wire{
public:
	bool value;
	char state;
};

struct Inp{
	int wit;
	int reverse;
};

class Component{
public:
	Component(){used = 0;}
	virtual void evaluate() = 0;
	virtual void set(vector<bool>) = 0;
	vector<bool> get(){return o;};
	void setuse(bool setter){used = setter;}
	bool getuse(){return used;}
	int getdet(){return detect;}
//protected:
	bool used;
	int detect;
	vector<bool> i;
	vector<bool> o;
};

class NOT : public Component{
public:
	NOT(){detect = 1;}
	void evaluate();
	void set(vector<bool> inputed);
protected:
	bool not(vector<bool>);
};

class AND : public Component{
public:
	AND(){detect = 2;}
	void evaluate();
	void set(vector<bool> inputed);
protected:
	bool and(vector<bool>);
};

class NAND : public Component{
public:
	NAND(){detect = 3;}
	void evaluate();
	void set(vector<bool> inputed);
protected:
	bool and(vector<bool>);
	bool nand(vector<bool>);
};

class OR : public Component{
public:
	OR(){detect = 4;}
	void evaluate();
	void set(vector<bool> inputed);
protected:
	bool or(vector<bool>);
};

class NOR : public Component{
public:
	NOR(){detect = 5;}
	void evaluate();
	void set(vector<bool> inputed);
protected:
	bool or(vector<bool>);
	bool nor(vector<bool>);
};

class XOR : public Component{
public:
	XOR(){detect = 6;}
	void evaluate();
	void set(vector<bool> inputed);
protected:
	bool xor(vector<bool>);
};

class XNOR : public Component{
public:
	XNOR(){detect = 7;}
	void evaluate();
	void set(vector<bool> inputed);
protected:
	bool xor(vector<bool>);
	bool xnor(vector<bool>);
};

class MULT : public Component{
public:
	MULT(){detect = 8;}
	void evaluate();
	void set(vector<bool> inputed);
protected:
	bool mult(vector<bool>);
};

class DFF : public Component{
public:
	DFF();
	void evaluate();
	void set(vector<bool> inputed);
	void resetchange(){change = 0;}
	bool getchange(){return change;}
	bool getstore(){return store;}
protected:
	bool pclock,change,store;
};

class Intelligent : public Component{
public:
	void evaluate();
	void set(vector<bool>);
	Intelligent(string,vector<Intelligent *>,vector<Component *>,int,int,bool);
	virtual ~Intelligent();
	int getout() {return outnum;}
	void wireblank(int);
//protected:
	void reset();
	bool validity(int position);
	bool endprim(int position);
	bool endinte(int position);
	void transtruth(int position);
	void translate(int position);
	bool detectdff(int position);
	void setprob(int position);
	void predff();
	void inteldetermine(int position);
	void checkprob(int position);

	ifstream myfile;
	string imp;
	vector<Intelligent *> IQ;
	vector<Component *> primitives;
	vector<Wire> iw;
	int inum,outnum;
	bool mykind;
};

#endif