#include <afxcmn.h>
#include <afxdlgs.h>
#include <afxwin.h>
#include <time.h>
#include "Logic.h"
#include "App_ids.h"
#include <string>
#include <ctype.h>
#include <iostream>
#include <stdlib.h>
#include "Circuit.h"
#include "CWave.h"
#include "resource.h"


using namespace std;

void CLogic::routekill()
{
	for(int i=0 ; i<5 ; i++)
	{
		Ver[i]=0;
		Hor[i]=0;
	}
	Ver [5]=0;
	in.clear();
	out.clear();
	wire.clear();
	for ( i = 0; i < display.size() ; i++ )
	{
		display[i].I.clear();
		display[i].O.clear();
		display[i].loc = 0;
	}
	display.clear();
}


CLogic::CLogic()
{
	Create( NULL, "Logic Simulator", WS_OVERLAPPEDWINDOW,
		CRect(0,0,800,600), NULL, "Main");
	srand ( time(NULL) );

	
	HICON hicon=AfxGetApp()->LoadIcon(IDR_ICON1);
    SetIcon(hicon,FALSE);
	SetIcon(hicon,TRUE);

	m_avi.Create(WS_VISIBLE | WS_CHILD | ACS_AUTOPLAY, 
		CRect(675, 40, 745, 110), this, IDC_ANIMATE1);

	BOOL b = m_avi.Open(IDC_ANIMATE1); // open the avi resource.
    *expression = '\0';
	Check = false;
}

void CLogic::showbmp(int x,int y,char* name)
{
	CBitmap bmpHello;
	bmpHello.LoadBitmap( name );
	BITMAP bm;
	bmpHello.GetObject( sizeof(BITMAP), &bm );
	CDC dcMem;
	dcMem.CreateCompatibleDC( P );
	CBitmap* pbmpOld = dcMem.SelectObject( &bmpHello) ;
	P->BitBlt( x, y, bm.bmWidth,bm.bmHeight,
		&dcMem, 0, 0 ,SRCCOPY );
	dcMem.SelectObject( pbmpOld );
}

afx_msg void CLogic::OnExit()
{
	SendMessage( WM_CLOSE );
}

afx_msg void CLogic::OnOpen()
{
	CFileDialog file(TRUE);
	file.m_ofn.lpstrFilter ="Simulation Files(*.crt)\0*.crt\0\0";

	if( IDOK == file.DoModal() )
	{
		char Address_temp [500]; 
		strcpy( Address_temp, file.GetPathName() );
		char* Ad_ptr = Address;
		char* temp = Address_temp;
		while ( *temp )
		{
			if ( *temp == '\\' )	 
			{
				*Ad_ptr++ = '\\'; 
			}
			*Ad_ptr ++ = *temp++;
		}
		*Ad_ptr = '\0';

		Check = true;

	}
    InvalidateRect (NULL,FALSE) ;
	
}

afx_msg void CLogic::OnPaint()
{
	CPaintDC Temp (this);
	P = &Temp;
	CBrush gray;
	gray.CreateSolidBrush( RGB(253,255,206) );
	CBrush *pBrush = P->SelectObject(&gray);
	P->Rectangle(10,10,630,515);
	P->SelectObject(pBrush);
	if (Check) 
	{
		f = fopen( ( const char* ) Address,"r");
		Init() ;
		fclose(f);
	}
}

void CLogic::Drawpath( int len)
{
	P->MoveTo(points[0].x,points[0].y);
	for( int i=1; i<len; i++)
		P->LineTo(points[i].x,points[i].y);
}

int CLogic::path( POINT a,POINT b)
{
	POINT cur;
	points[0]=a;
	points[5]=b;
	
	int V1 = ( a.x - 10 ) / 115;
	
	int V2 = ( b.x - 10 ) / 115;
	
	int first =  router( Ver[ V1 ] );
	
	cur.x = ((55+115*V1) == a.x ) ? (a.x-45+first) : (a.x+first);
	
	cur.y = a.y;

	points[1]=cur;
	if (V1 == V2)
	{
		cur.y = b.y;
		points[2]=cur;
		points[3]=b;
		return 4;
	}
	int H1 = ( ( a.y - 10 ) /115 ) ;
	
	int second = router( Hor[H1] );

	points[2]=b;
	cur.x = points[1].x;
	cur.y = (10+115*H1) + second ;
	points[2]=cur;

	
	int third = router( Ver[ V2] );
	cur.x = 10 + 115 * V2 + third;
	
	cur.y = points[2].y;
	points[3]=cur;

	cur.x = points[3].x;
	cur.y = b.y;
	points[4]=cur;

	
	return 6;
}

void CLogic::OnRun()
{
	Circuit * my;
	int mydelay = starter(Address,&my);
	CFrameWnd * mojwin = new CWave(mydelay,my);
	mojwin -> ShowWindow( SW_SHOW );
	//mojwin -> UpdateWindow();
	
}


BEGIN_MESSAGE_MAP( CLogic, CFrameWnd )
	ON_COMMAND ( IDM_EXIT , OnExit )
	ON_COMMAND ( IDM_OPEN , OnOpen )
	ON_COMMAND ( IDM_RUN  , OnRun  )
	ON_WM_PAINT()
END_MESSAGE_MAP()


int CLogic::router( int& F)
{
	static a[]={1,3,7,15};
	if ( F==0 )
	{
		F++;
		return 22;
	}
	int i = 0;
	while ( F >= a[i+1] ) i++;
	int Result = ( 2*( F - a[i] )+1) * ( 45 / (a[i+1]+1) );
	F++ ;
	return Result;
}

void CLogic::tokenizer()
{
	char* tok_ptr = token;
	*tok_ptr = '\0';
	if ( ( *exp_ptr == ')' ) || ( *exp_ptr == 10 ) ) return;
	while ( isspace( *exp_ptr ) || ( strchr( "(," , *exp_ptr ) ) ) ++exp_ptr;
	if ( ( *exp_ptr == ')' ) || ( *exp_ptr == 10 ) ) return;
	if (!*exp_ptr) return;
	while ( isalnum( *exp_ptr) )
		*tok_ptr++ = *exp_ptr++;
	*tok_ptr = '\0';
}

void CLogic::line()
{
	fgets( expression, MAXLINE, f);
	while ( strstr( expression, "//" ) || ( *expression== 10)  ) 
		fgets( expression, MAXLINE, f);
	exp_ptr = expression;
	while (*exp_ptr)
	{
		*exp_ptr = tolower( *exp_ptr);
		exp_ptr++;
	}

	exp_ptr = expression;
}

void Readline( FILE* F, char* buffer)
{
	fgets( buffer, 200 , F);
	char* strptr = buffer;
	while (*strptr)
	{
		*strptr = tolower( *strptr);
		strptr++;
	}
}

int CLogic::in_count()
{
	if ( !strcmp(token , "dff" ) ) return 2;
	else if ( Isprim( token ) ) return 1;
	else 
	{
		FILE* myfile;
		char ad [40];
		strcpy(ad,token);
		strcat(ad,".crt");
		myfile = fopen( ( const char* )ad , "r" );
		char Line [200];
		Readline( myfile , Line);
		int temp = 0;
		
		while  (!strstr( Line, "output") )
		{
			if ( strstr( Line,"//")) 
			{
				Readline( myfile,Line);
				continue;
			}
			Readline( myfile,Line);
		}
		char* str_ptr = Line;
		while (* str_ptr)
		{
			if ( *str_ptr == ',' ) temp++;
			str_ptr++;
		}
		return temp+1;
	}
}


bool CLogic::Isprim( char* seq)
{
	return strstr("and@or@dff@multiplexer@nand@nor@not@xor@xnor",seq);
}

void CLogic::printname( int x, int y)
{
	P->SetBkColor(RGB( 154, 174, 255));       
	CFont font;
	CFont* oldfont = P->SelectObject( &font );
	font.CreateFont(1,0,0,0,FW_BOLD,5,0,0,0,
		0,0,0,0,"Times New Roman");
	P->TextOut( x + 10, y + 26, token, 
		( strlen(token)>=7 ) ? 7 : strlen(token) );
	P->SelectObject( & oldfont );


}

void CLogic::Init()
{
	routekill();
	int order [20] ={10,20,11,21,12,22,13,23,14,24
		,0,30,1,31,2,32,3,33,4,34};

	line();
	tokenizer();
	tokenizer();
	
	while ( *token )
	{
		string add = token;
		in.push_back( add );
		tokenizer();
	}
	line();
	tokenizer();
	tokenizer();
	
	while ( *token )
	{
		string add = token;
		out.push_back( add );
		tokenizer();
	}
	
	line();
	tokenizer();
	tokenizer();

	while ( *token )
	{
		string add = token;
		wire.push_back( add );
		tokenizer();
	}
	line();
	
	int pos = 0;

	line();
	while ( ! strstr(expression,"end description") )
	{
		if ( !strstr(expression,"prob") )
		{
			int m = order[pos] / 10;
			int n = order[pos] - (order[pos]/10)*10;
			tokenizer();
			if ( Isprim(token) )
			showbmp( n*115+55,m*115+55, token );
			
			else 
			{
				showbmp( n*115+55,m*115+55, "com" );
				printname( n*115+55, m*115+55);
			}
			
			

			int count = in_count();
						
			element cur;
						
			for ( int index=0; index<count;index++)
			{
				tokenizer();
				string add = token;
				cur.O.push_back(add);
			}
			tokenizer();
			while (*token)
			{
				string add = token;
				cur.I.push_back(add);
				tokenizer();
			}
			cur.loc=order[pos];
			pos++;
			display.push_back(cur);
		}
	line();
	}
	joinwires();
	join_in();
	join_out();
}

int CLogic::find(vector<string> whattofind, string F)
{
	for ( int i=0; i<whattofind.size(); i++)
		if ( F == whattofind[i] ) return i;
	return -1;
}

int CLogic::find(vector<int> whattofind, int F)
{
	for ( int i=0; i<whattofind.size(); i++)
		if ( F == whattofind[i] ) return i;
	return -1;
}

void CLogic::joinwires()
{
	int loc1=0,loc2=0;
	int inth=0,outh=0;
	int ipos=0,opos=0;
	for ( int index = 0; index < wire.size() ; index++)
	{
		for ( int i=0; i<display.size(); i++)
		{
			inth = find(display[i].I,wire[index]);
			if ( inth != -1 )
			{
				loc1 = display[i].loc;
				ipos=i;
				break;
			}
		}
		for ( i = 0; i < display.size(); i++)
		{
			outh = find(display[i].O,wire[index]);
			if ( outh != -1 )
			{
				loc2 = display[i].loc;
				opos=i;
				break;
			}
		}
	if ( ( inth != -1 ) && ( outh != -1 ) )
	{
		int x1 = ( loc1-(loc1/10)*10 ) * 115+55;
		int y1 = ( loc1 / 10 ) * 115+55+(rand()%2-1)*(rand()%6);
		int x2 = ( loc2-(loc2/10)*10 ) * 115+55;
		int y2 = ( loc2 / 10 ) * 115+55+(rand()%2-1)*(rand()%6);
		y1 += ((inth+1)*70) / (display[ipos].I.size()+1);
		x2 += 70;
		y2 += ((outh+1)*70) / (display[opos].O.size()+1);
		POINT a = {x1,y1};
		POINT b = {x2,y2};
		int len = path( a, b);
		Drawpath(len);
	}
	}
}

void CLogic::join_out()
{
	int loc1=0;
	int inth=0;
	int ipos=0;
	int unit = 505 / ( out.size() + 1);
	for ( int index = 0; index<out.size() ; index++)
	{
		for ( int i = 0;i < display.size();i++)
		{
			inth = find( display[i].O,out[index] );
			if ( inth != -1 )
			{
				loc1 = display[i].loc;
				ipos = i;
				break;
			}
		}
	if  ( inth != -1 ) 
	{
		int x2 = (loc1-(loc1/10)*10) * 115+125;
		int y2 = (loc1/10)*115+55+(rand()%2-1)*(rand()%6);
		y2+=( (inth+1) * 70 )/( display[ipos].O.size() +1 );
		int x1 = 630;
		int y1 = (index + 1) * unit + 10+(rand()%2-1)*(rand()%6);
		POINT a = {x1,y1};
		POINT b = {x2,y2};
		int len = path( a, b);
		Drawpath(len);
	}
	}
}




void CLogic::join_in()
{
	int loc1=0;
	int inth=0;
	int ipos=0;
	int unit = 505 / ( in.size() + 1);
	for ( int index = 0; index<in.size() ; index++)
	{
		for ( int i = 0;i < display.size();i++)
		{
			inth = find( display[i].I,in[index] );
			if ( inth != -1 )
			{
				loc1 = display[i].loc;
				ipos = i;
				break;
			}
		}
	int x2 = (loc1-(loc1/10)*10) * 115+55;
	int y2 = (loc1/10)*115+55+(rand()%2-1)*(rand()%6);
	y2+=( (inth+1) * 70 )/( display[ipos].I.size() +1 );
	int x1 = 10;
	int y1 = (index + 1) * unit + 10+(rand()%2-1)*(rand()%6);
	POINT a = {x1,y1};
	POINT b = {x2,y2};
	int len = path( a, b);
	Drawpath(len);

	}
}

CLogic::~CLogic()
{
	for ( int i = 0 ; i < display.size() ; i++)
		delete display[i].name;
}

class LogicApp : public CWinApp
{
public:
	BOOL InitInstance()
	{
		m_pMainWnd = new CLogic;
		m_pMainWnd->ShowWindow( m_nCmdShow );
		m_pMainWnd->UpdateWindow();
		return TRUE;
	}
} ob;

