#include "Mainan.h"
#include "Circuit.h"

//MAINAN
Mainan::Mainan(const char * path,Circuit ***mycomp) throw(Err){
	online = myarray = onename = 0;
	endline = 0;
	testfile.open(path);
	thedelay = 0;

	if (!testfile){
		string pass = "File not found : ";
		pass += path;
		throw file(pass);
	}

	try{
		checker();
	}catch(...){
		testfile.close();
		throw;
	}

	testfile.close();//reuse of file needed
	try{
		infile.open(path);

		infile.get(nextline);  
		length = 256;
		onename = new char[2];

		if (onename == 0)
			throw outmem("Out of memory");

		strcpy(onename,"@");

		makecomponents();
		**mycomp = new Circuit(tempimp,tempIQ,tempprimitives,tempinum,tempoutnum,tempmykind,thedelay);

		if (**mycomp == 0)
			throw outmem("Out of memory");

		(**mycomp)->wireblank(wt.size());
	}catch(...){
		infile.close();

		if (onename != 0)
			delete []onename;

		onename = 0;

		if (myarray != 0)
			delete []myarray;

		myarray = 0;

		throw;
	}
}

//MAKECOMPONENTS
void Mainan::makecomponents(){
	Analyzor::makecomponents();

	while(strcmp(onename,"data") != 0 && nextline != '#')
		tokener();

	if(nextline == '#'){
		string pass = "Unexpected end of file";
		throw syntax(pass);
	}

	harry_data();
}

//HARRY_DATA
void Mainan::harry_data(){
	shared.open("tempshar.nef");

	while(strcmp(onename,"start") != 0 && nextline != '#'){
		tokener();

		if(strcmp(onename,"rev") == 0)
			rever();
	}

	if(nextline == '#'){
		string pass = "Unexpected end of file";
		throw syntax(pass);
	}

	shared << '{' << endl;

	tokener();

	while(strcmp(onename,"stop") != 0 && nextline != '#'){

		if((onename[0] >= 'a' && onename[0] <= 'z') || (onename[0] >= '0' && onename[0] <= '9'))
			assigner();

		if(onename[0] == '&')
			delayer();

		tokener();
	}

	if(nextline == '#'){
		string pass = "Unexpected end of file";
		throw syntax(pass);
	}

	while(strcmp(onename,"end") != 0 && nextline != '#')
		tokener();

	if(nextline == '#'){
		string pass = "Unexpected end of file";
		throw syntax(pass);
	}

	tokener();

	if(strcmp(onename,"data") != 0 && nextline == '#'){
		string pass = "Unexpected end of file";
		throw syntax(pass);
	}

	shared << '}' << endl;

	shared.close();
}

//ASSIGNER
void Mainan::assigner(){
	char who,where;
	int result = 0;

	findplace(who,where);

	if(who != 'i'){
		string pass = "In data block only inputs can be assigned";
		throw syntax(pass);
	}

	tokener();

	if(!(onename[0] == '=') || endline == 1 || nextline == '#'){
		string pass = "After input = expected";
		throw syntax(pass);
	}

	tokener();

	if(!(onename[0] >= '0' && onename[0] <= '9') || endline == 1 || nextline == '#'){
		string pass = "After = number expected";
		throw syntax(pass);
	}

	for (int i = 0;onename[i] >= '0' && onename[i] <= '9';i++)
		result = result * 10 + ((int)onename[i] - (int)'0');

	shared << "= " << (int)where << ' ' << result << endl;
}

//DELAYER
void Mainan::delayer(){
	int result = 0;

	tokener();

	if(!(onename[0] >= '0' && onename[0] <= '9') || endline == 1 || nextline == '#'){
		string pass = "After & number expected";
		throw syntax(pass);
	}

	for (int i = 0;onename[i] >= '0' && onename[i] <= '9';i++)
		result = result * 10 + ((int)onename[i] - (int)'0');

	shared << "& " << result << endl;
	thedelay += result;
}



//REVER
void Mainan::rever(){
	char who,where;
	int result = 0;

	tokener();

	if(!((onename[0] >= 'a' && onename[0] <= 'z') || (onename[0] >= '0' && onename[0] <= '9')) || endline == 1 || nextline == '#'){
		string pass = "After rev input expected";
		throw syntax(pass);
	}

	findplace(who,where);

	if(who != 'i'){
		string pass = "After rev input expected";
		throw syntax(pass);
	}

	tokener();

	if(!(onename[0] == ':') || endline == 1 || nextline == '#'){
		string pass = "After rev's input : expected";
		throw syntax(pass);
	}

	tokener();

	if(!(onename[0] >= '0' && onename[0] <= '9') || endline == 1 || nextline == '#'){
		string pass = "After : number expected";
		throw syntax(pass);
	}

	for (int i = 0;onename[i] >= '0' && onename[i] <= '9';i++)
		result = result * 10 + ((int)onename[i] - (int)'0');

	shared << "! " << (int)where << ' ' << result << endl;
}